﻿/**
 * Copyright 2008 - TMTDigital LLC
 *
 * Author:   Travis Tidwell (www.travistidwell.com)
 * Version:  1.0
 * Date:     June 9th, 2008
 *
 * Description:  The Preview Mask handles the preview image and the mask in front.
 *
 **/

package com.tmtdigital.dash.display.media
{
   import com.tmtdigital.dash.display.Skinable;
   import com.tmtdigital.dash.display.Image;   

   import flash.display.*;
   import flash.net.*;
   import flash.geom.*;

   class PreviewMask extends Skinable
   {
      public function PreviewMask( _skin:MovieClip )
      {
         super( _skin );
      }

      public override function setSkin( _skin:MovieClip )
      {
         super.setSkin( _skin );
         previewImage = "";
         maskMC = skin.maskMC;
         preview = new Image( skin.preview );
      }

      public function postResize( mediaRect:Rectangle )
      {
         if( maskMC ) {
            maskMC.width = mediaRect.width;
            maskMC.height = mediaRect.height;
         }
         
         if( preview ) {			
          	preview.resize( mediaRect );   
         } 
      }

      public function setPlayState( _play:Boolean, _showImage:Boolean )
      {
         if( maskMC ) {
            maskMC.visible = !_play;
         }
         
         if( preview ) {
            preview.visible = _showImage;
         }
      }

      public function getPreview() : String
      {
         return previewImage;
      }

      public function unloadPreview()
      {
         if ( preview ) {
            preview.clearImage();
         }
      }

      public function loadPreview( _file:String, _onLoaded:Function )
      {
         onLoaded = _onLoaded;
         if ( preview && _file) {
            previewImage = _file;		
            preview.loadImage( _file, onPreviewLoaded );
         }
      }

      private function onPreviewLoaded()
      {
         if( maskMC ) {
            maskMC.visible = false;
         }      
         
         if( onLoaded is Function ) {
            onLoaded();
         }
      }

      public var preview:Image;
      public var maskMC:Sprite;

      private var previewImage:String;
      private var onLoaded:Function;
   }
}